<template>
  <div>
    <su-service :icon="'filter'">
      <template #title>
        Filtrer les initiatives
      </template>
      Filtrer les inititatives selon les actions mises en place, si elles sont portées par la direction de leur laboratoire
      ou encore si elles ont réalisé un BGES (Bilan de Gaz à Effet de Serre).
      <br />
      <br />
      <b-taginput
        @input="changeTypeFilter"
        v-model="filters"
        field="valeur"
        icon="caret-right"
        :data="initiatives_categories"
        :allow-new="false"
        rounded
        placeholder="Ajouter un filtre"
        :open-on-focus="true"
        autocomplete
      >
        <template slot-scope="props">
          {{props.option.valeur}}
        </template>
        <template slot="empty">
          Proposer au mimimum une initiative
        </template>
      </b-taginput>
      <br />
      <b-checkbox
        v-model="isInstitutionnelle"
        @input="changeInstitutionFilter"
      >
        Portées par la direction du laboratoire
      </b-checkbox>
      <br />
      <b-checkbox
        v-model="hasBGESenCourt"
        @input="changeBGESenCourtFilter"
      >
        BGES en cours
      </b-checkbox>
      <br />
      <b-checkbox
        v-model="hasBGESdone"
        @input="changeBGESdoneFilter"
      >
        BGES réalisé
      </b-checkbox>
    </su-service>
    <br />
    <div class="box-blue">
      <strong>{{initiatives.length}}</strong> initiative<span v-if="initiatives.length >=2">s</span> répertoriée<span v-if="initiatives.length >=2">s</span>.
    </div>
    <br />
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import SUService from '@/components/SUService.vue'

export default {
  name: 'ResumeInitiatives',
  props: ['initiatives'],
  components: {
    'su-service': SUService
  },
  data: function () {
    return {
      filters: [],
      isInstitutionnelle: false,
      hasBGESenCourt: false,
      hasBGESdone: false,
      initiatives_categories: [
        { 'valeur': 'Engagements' },
        { 'valeur': 'Activités de recherche' },
        { 'valeur': 'Groupe de réflexion' },
        { 'valeur': 'Déplacements professionnels' },
        { 'valeur': 'Déplacements domicile-travail' },
        { 'valeur': 'Bâtiments' },
        { 'valeur': 'Numérique' },
        { 'valeur': 'Actions éco-responsables' },
        { 'valeur': 'Initiatives à portée sociale' },
        { 'valeur': 'Enquêtes' },
        { 'valeur': 'Communication' },
        { 'valeur': 'Autres' }
      ]
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated'])
  },
  methods: {
    openAuthModal () {
      this.$store.dispatch('authentication/openAuthModal')
    },
    changeTypeFilter () {
      this.$emit('filterChanged', this.filters.map(a => a.valeur))
    },
    changeInstitutionFilter () {
      if (this.isInstitutionnelle) {
        this.$emit('filterChanged', 'isInstitutionnelle')
      } else {
        this.$emit('filterChanged', 'isNotInstitutionnelle')
      }
    },
    changeBGESenCourtFilter () {
      if (this.hasBGESenCourt) {
        this.$emit('filterChanged', 'hasBGESenCourt')
      } else {
        this.$emit('filterChanged', 'hasNotBGESenCourt')
      }
    },
    changeBGESdoneFilter () {
      if (this.hasBGESdone) {
        this.$emit('filterChanged', 'hasBGESdone')
      } else {
        this.$emit('filterChanged', 'hasNotBGESdone')
      }
    }
  }
}
</script>
